unit fOpenAIChatBot_Controls;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics,
  Controls, Forms, Dialogs, ImageList, ImgList,
  StdCtrls, Vcl.Menus;

type
  TFRMOpenAIChatBot_Controls = class(TForm)
    btnControlAudio: TButton;
    ImageList1: TImageList;
    PopupMenu1: TPopupMenu;
    Start1: TMenuItem;
    Stop1: TMenuItem;
    N1: TMenuItem;
    Configuration1: TMenuItem;
    N2: TMenuItem;
    Exit1: TMenuItem;
    procedure btnConfigurationClick(Sender: TObject);
    procedure btnControlAudioClick(Sender: TObject);
    procedure btnStopClick(Sender: TObject);
    procedure Configuration1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Start1Click(Sender: TObject);
    procedure Stop1Click(Sender: TObject);
  private
    FOnControlConfiguration: TNotifyEvent;
    FOnControlStart: TNotifyEvent;
    FOnControlStop: TNotifyEvent;
    FOnControlExit: TNotifyEvent;
  private
    FListening: Boolean;
    procedure SetListening(const Value: Boolean);
  protected
    procedure DoControlStart; virtual;
    procedure DoControlStop; virtual;
    procedure DoControlConfiguration; virtual;
    procedure DoControlExit; virtual;
  public
    property Listening: Boolean write SetListening;
  public
    property OnControlConfiguration: TNotifyEvent read FOnControlConfiguration
        write FOnControlConfiguration;
    property OnControlExit: TNotifyEvent read FOnControlExit write FOnControlExit;
    property OnControlStart: TNotifyEvent read FOnControlStart write
        FOnControlStart;
    property OnControlStop: TNotifyEvent read FOnControlStop write FOnControlStop;
  end;

var
  FRMOpenAIChatBot_Controls: TFRMOpenAIChatBot_Controls;

implementation

{$R *.dfm}

procedure TFRMOpenAIChatBot_Controls.btnConfigurationClick(Sender: TObject);
begin
  DoControlConfiguration;
end;

procedure TFRMOpenAIChatBot_Controls.btnControlAudioClick(Sender: TObject);
begin
  if FListening then
    DoControlStop
  else
    DoControlStart;
end;

procedure TFRMOpenAIChatBot_Controls.btnStopClick(Sender: TObject);
begin
  DoControlStop;
end;

procedure TFRMOpenAIChatBot_Controls.Configuration1Click(Sender: TObject);
begin
  DoControlConfiguration;
end;

procedure TFRMOpenAIChatBot_Controls.DoControlConfiguration;
begin
  if Assigned(FOnControlConfiguration) then
    FOnControlConfiguration(self);
end;

procedure TFRMOpenAIChatBot_Controls.DoControlExit;
begin
  if Assigned(FOnControlExit) then
    FOnControlExit(self);
end;

procedure TFRMOpenAIChatBot_Controls.DoControlStart;
begin
  if Assigned(FOnControlStart) then
    FOnControlStart(self);
end;

procedure TFRMOpenAIChatBot_Controls.DoControlStop;
begin
  if Assigned(FOnControlStop) then
    FOnControlStop(self);
end;

procedure TFRMOpenAIChatBot_Controls.Exit1Click(Sender: TObject);
begin
  DoControlExit;
end;

procedure TFRMOpenAIChatBot_Controls.FormShow(Sender: TObject);
begin
  Left := Screen.WorkAreaRect.Right - Width;
  Top := Screen.WorkAreaRect.Bottom - Height;
end;

procedure TFRMOpenAIChatBot_Controls.SetListening(const Value: Boolean);
begin
  FListening := Value;
  if FListening then
    btnControlAudio.ImageIndex := 1
  else
    btnControlAudio.ImageIndex := 0;
  Application.ProcessMessages;
end;

procedure TFRMOpenAIChatBot_Controls.Start1Click(Sender: TObject);
begin
  DoControlStart;
end;

procedure TFRMOpenAIChatBot_Controls.Stop1Click(Sender: TObject);
begin
  DoControlStop;
end;

end.
